@ECHO off
REM Licensed Materials - Property of IBM
REM 
REM 5724-A57 5724-J10 5724-N15
REM 
REM (C) Copyright IBM Corporation 2009. All Rights Reserved.
REM 
REM US Government Users Restricted Rights- Use, duplication or disclosure
REM restricted by GSA ADP Schedule Contract with IBM Corp.


CALL "%~dp0\installSupport\GetShortName.bat" "%~dp0" CUR_DIR
CALL "%~dp0\installSupport\GetShortName.bat" "%CommonProgramFiles%" SLTemp
cd /d "%~dp0"

set ANT_HOME=%CUR_DIR%\src\iru_ant
set PATH=%ANT_HOME%\bin;%PATH%

    if "%OS%"=="Windows_NT" @setlocal
    if "%OS%"=="WINNT" @setlocal

REM set default response file
set responseFileArg=-Dinstall_cfg.properties="IRU_install.properties"

REM set temp directory to copy Solution Deployer needed files.
:gettempdir
    IF {%SLTemp%} == {} SET SLTemp=%homedrive%%homepath%
    IF {%SLTemp%} == {} SET SLTemp=%SystemDrive%
    IF {%SLTemp%} == {} SET SLTemp=C:
    SET SLTemp=%SLTemp%\SL_%RANDOM%
    MKDIR "%SLTemp%" >nul 2>nul
REM get the command line arguments. This loop allows for an unlimited number
REM of arguments (up to the command line limit).
:setupArgs
    if ""%1""=="""" goto extractJVM
    if ""%1""==""-responseFile"" goto setResponseFile
    if ""%1""==""-taskFile"" goto setTaskFile
    if ""%1""==""-silent"" goto setSilent
    if ""%1""==""-launchpadLocale"" goto setLocale
    if ""%1""==""-solutionDir"" goto setsolutionDir
    if ""%1""==""-help"" goto displayOptions
    goto displayOptions

REM set Response file if options are passed through command line.
:setResponseFile
   if ""%2""=="""" goto displayOptions
   if exist %2 (
    set responseFileArg=-Dinstall_cfg.properties=%2
    shift
    shift
    goto setupArgs
    ) else (
      echo The file %2 does not exist
      echo The file %2 does not exist > "%SLTemp%"\invalidoptions.txt 
      echo http://publib.boulder.ibm.com/infocenter/satinfo/v3r2/index.jsp?topic=/com.ibm.sat.doc/tasks/t_solution_launcher_install.htm >> "%SLTemp%"\invalidoptions.txt
      goto mainExit
    )

REM set task file if options are passed through command line.
:setTaskFile
    if ""%2""=="""" goto displayOptions
   if exist %2 (
    set taskFileArg=-DtaskFile=%2
    shift
    shift
    goto setupArgs
    ) else (
      echo The file %2 does not exist
      echo The file %2 does not exist > "%SLTemp%"\invalidoptions.txt 
      echo http://publib.boulder.ibm.com/infocenter/satinfo/v3r2/index.jsp?topic=/com.ibm.sat.doc/tasks/t_solution_launcher_install.htm >> "%SLTemp%"\invalidoptions.txt
      goto mainExit
    )

REM set locale if option is passed through command line.
:setLocale
    if ""%2""=="""" goto displayOptions
    set localeArgument=-Duser.language=%2
    set localeLaunchpad=-Dlaunchpad.language="true"
    shift
    shift
    goto setupArgs

REM set directory where solution and log files will be stored
:setsolutionDir
    if ""%2""=="""" goto displayOptions
    set solutionDir=-DsolutionDir=%2
    shift
    shift
    goto setupArgs

REM set silent installation and options to bypass lap screen.
:setSilent
    set SilentInstall=-Dsilent="true"
    shift
    goto setupArgs


REM Display available options        
:displayOptions
    echo http://publib.boulder.ibm.com/infocenter/satinfo/v3r2/index.jsp?topic=/com.ibm.sat.doc/tasks/t_solution_launcher_install.htm
    echo http://publib.boulder.ibm.com/infocenter/satinfo/v3r2/index.jsp?topic=/com.ibm.sat.doc/tasks/t_solution_launcher_install.htm > "%SLTemp%"\invalidoptions.txt 
    goto mainExit
REM extract jvm from target directory.
:extractJVM
    MKDIR "%SLTemp%"\SolutionEnabler\DJTJRE >nul 2>nul
    copy /B /V %CUR_DIR%\bin\targets\windows\ibm_win32_jre.exe "%SLTemp%\SolutionEnabler\DJTJRE" >nul 2>&1
    copy /V /Y %CUR_DIR%\installSupport\Clean.bat "%SLTemp%" >nul 2>&1
    cd /D "%SLTemp%\SolutionEnabler\DJTJRE"
    call "%SLTemp%\SolutionEnabler\DJTJRE\ibm_win32_jre.exe" >nul 2>&1
    cd /D %CUR_DIR%
    xcopy /S /V /Q %CUR_DIR%\bin\lib "%SLTemp%\SolutionEnabler\DJTJRE\lib" >nul 2>&1
    set JAVA_HOME="%SLTemp%\SolutionEnabler\DJTJRE"

REM check to ensure that jvm has been expanded correctly
:checkJVM
    if "%JAVA_HOME%" == "" goto mainExit
    if not exist "%JAVA_HOME%\bin\java.exe" goto mainExit
    if "%_JAVACMD%" == "" set _JAVACMD=%JAVA_HOME%\bin\java.exe

REM Start Solution Deployer
:startInstall
    set ANT_OPTS=-Dlog.locationFileDir=%SLTemp%\SolutionEnabler\logs
    IF NOT "%localeArgument%"=="""" set ANT_OPTS=%localeArgument% %ANT_OPTS%
    call ant -lib %ANT_HOME%\lib -f install.xml log-environment -Dcurrent.dir=%CUR_DIR% %solutionDir% >nul 2>&1
    call ant -lib %ANT_HOME%\lib -f install.xml %responseFileArg% %taskFileArg% %solutionDir% %SilentInstall% %localeArgument% %localeLaunchpad% -Dcurrent.dir=%CUR_DIR% -Dinstall.tmp.dir="%SLTemp%" > %SLTemp%/antmessages.log

:mainExit
    if "%OS%"=="Windows_NT" @endlocal
    if "%OS%"=="WINNT" @endlocal
    exit /B %errorlevel%
